diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/spectrum-wifi-phy.cc ns-3.45/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.44/src/wifi/model/spectrum-wifi-phy.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/spectrum-wifi-phy.cc	2025-06-01 20:34:45.624702200 -0700
@@ -141,57 +141,87 @@
     return bands;
 }
 
-HeRuBands
-SpectrumWifiPhy::GetHeRuBands(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface,
-                              MHz_u guardBandwidth)
+RuBands
+SpectrumWifiPhy::GetRuBands(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface,
+                            MHz_u guardBandwidth)
 {
-    HeRuBands heRuBands{};
+    RuBands ruBands{};
     const auto channelWidth = spectrumPhyInterface->GetChannelWidth();
-    for (MHz_u bw = channelWidth; bw >= MHz_u{20}; bw = bw / 2)
+    const auto p20Index = GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20});
+    std::vector<WifiModulationClass> modClasses{WIFI_MOD_CLASS_HE};
+    if (GetStandard() >= WIFI_STANDARD_80211be)
     {
-        for (uint32_t i = 0; i < (channelWidth / bw); ++i)
+        modClasses.push_back(WIFI_MOD_CLASS_EHT);
+    }
+    for (const auto modClass : modClasses)
+    {
+        for (MHz_u bw = channelWidth; bw >= MHz_u{20}; bw = bw / 2)
         {
-            for (uint32_t type = 0; type < 7; type++)
+            if (bw > GetMaximumChannelWidth(modClass))
             {
-                auto ruType = static_cast<HeRu::RuType>(type);
-                std::size_t nRus = HeRu::GetNRus(bw, ruType);
-                for (std::size_t phyIndex = 1; phyIndex <= nRus; phyIndex++)
+                continue;
+            }
+            for (uint8_t i = 0; i < (channelWidth / bw); ++i)
+            {
+                for (uint32_t type = 0;
+                     type <= static_cast<uint32_t>(WifiRu::GetMaxRuType(modClass));
+                     ++type)
                 {
-                    HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(bw, ruType, phyIndex);
-                    HeRu::SubcarrierRange subcarrierRange =
-                        std::make_pair(group.front().first, group.back().second);
-                    const auto bandIndices =
-                        HePhy::ConvertHeRuSubcarriers(bw,
-                                                      guardBandwidth,
-                                                      spectrumPhyInterface->GetCenterFrequencies(),
-                                                      spectrumPhyInterface->GetChannelWidth(),
-                                                      GetSubcarrierSpacing(),
-                                                      subcarrierRange,
-                                                      i);
-
-                    WifiSpectrumBandInfo band{};
-                    for (const auto& indicesPerSegment : bandIndices)
+                    const auto ruType = static_cast<RuType>(type);
+                    const auto nRus = WifiRu::GetNRus(bw, ruType, modClass);
+                    std::size_t undefRus{0};
+                    for (std::size_t phyIndex = 1; phyIndex <= nRus + undefRus; ++phyIndex)
                     {
-                        band.indices.emplace_back(indicesPerSegment);
-                        band.frequencies.emplace_back(
-                            ConvertIndicesToFrequenciesForInterface(spectrumPhyInterface,
-                                                                    indicesPerSegment));
+                        const auto group =
+                            WifiRu::GetSubcarrierGroup(bw, ruType, phyIndex, modClass);
+                        if (group.empty())
+                        {
+                            ++undefRus;
+                            continue;
+                        }
+                        const auto subcarrierRange =
+                            std::make_pair(group.front().first, group.back().second);
+                        const auto bandIndices = HePhy::ConvertRuSubcarriers(
+                            {bw,
+                             guardBandwidth,
+                             spectrumPhyInterface->GetCenterFrequencies(),
+                             spectrumPhyInterface->GetChannelWidth(),
+                             GetSubcarrierSpacing(),
+                             modClass,
+                             subcarrierRange,
+                             i});
+
+                        WifiSpectrumBandInfo band{};
+                        for (const auto& indicesPerSegment : bandIndices)
+                        {
+                            band.indices.emplace_back(indicesPerSegment);
+                            band.frequencies.emplace_back(
+                                ConvertIndicesToFrequenciesForInterface(spectrumPhyInterface,
+                                                                        indicesPerSegment));
+                        }
+                        WifiRu::RuSpec ru;
+                        if (modClass == WIFI_MOD_CLASS_HE)
+                        {
+                            const auto index = HeRu::GetIndexIn80MHzSegment(bw, ruType, phyIndex);
+                            const auto primary80 =
+                                HeRu::GetPrimary80MHzFlag(bw, ruType, phyIndex, p20Index);
+                            ru = HeRu::RuSpec{ruType, index, primary80};
+                        }
+                        else
+                        {
+                            const auto index = EhtRu::GetIndexIn80MHzSegment(bw, ruType, phyIndex);
+                            const auto& [primary160, primary80OrLow80] =
+                                EhtRu::GetPrimaryFlags(bw, ruType, phyIndex, p20Index);
+                            ru = EhtRu::RuSpec{ruType, index, primary160, primary80OrLow80};
+                        }
+                        NS_ABORT_IF(WifiRu::GetPhyIndex(ru, bw, p20Index) != phyIndex);
+                        ruBands.insert({band, ru});
                     }
-                    std::size_t index =
-                        (bw == MHz_u{160} && phyIndex > nRus / 2 ? phyIndex - nRus / 2 : phyIndex);
-                    const auto p20Index = GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20});
-                    bool primary80IsLower80 = (p20Index < bw / MHz_u{40});
-                    bool primary80 = (bw < MHz_u{160} || ruType == HeRu::RU_2x996_TONE ||
-                                      (primary80IsLower80 && phyIndex <= nRus / 2) ||
-                                      (!primary80IsLower80 && phyIndex > nRus / 2));
-                    HeRu::RuSpec ru(ruType, index, primary80);
-                    NS_ABORT_IF(ru.GetPhyIndex(bw, p20Index) != phyIndex);
-                    heRuBands.insert({band, ru});
                 }
             }
         }
     }
-    return heRuBands;
+    return ruBands;
 }
 
 void
@@ -203,12 +233,12 @@
     if (GetStandard() >= WIFI_STANDARD_80211ax)
     {
         const auto channelWidth = spectrumPhyInterface->GetChannelWidth();
-        auto&& heRuBands = GetHeRuBands(spectrumPhyInterface, GetGuardBandwidth(channelWidth));
-        for (const auto& bandRuPair : heRuBands)
+        auto&& ruBands = GetRuBands(spectrumPhyInterface, GetGuardBandwidth(channelWidth));
+        for (const auto& bandRuPair : ruBands)
         {
             allBands.push_back(bandRuPair.first);
         }
-        spectrumPhyInterface->SetHeRuBands(std::move(heRuBands));
+        spectrumPhyInterface->SetRuBands(std::move(ruBands));
     }
 
     spectrumPhyInterface->SetBands(std::move(bands));
@@ -527,10 +557,10 @@
 
     if (GetStandard() >= WIFI_STANDARD_80211ax)
     {
-        const auto& heRuBands =
-            interface ? interface->GetHeRuBands() : m_currentSpectrumPhyInterface->GetHeRuBands();
-        NS_ASSERT(!heRuBands.empty());
-        for (const auto& [band, ru] : heRuBands)
+        const auto& ruBands =
+            interface ? interface->GetRuBands() : m_currentSpectrumPhyInterface->GetRuBands();
+        NS_ASSERT(!ruBands.empty());
+        for (const auto& [band, ru] : ruBands)
         {
             auto rxPowerPerBand =
                 WifiSpectrumValueHelper::GetBandPowerW(receivedSignalPsd, band.indices);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/spectrum-wifi-phy.h ns-3.45/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.44/src/wifi/model/spectrum-wifi-phy.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/spectrum-wifi-phy.h	2025-06-01 20:34:45.624702200 -0700
@@ -33,7 +33,7 @@
 struct WifiSpectrumSignalParameters;
 
 /// Map a spectrum band associated with an RU to the RU specification
-using HeRuBands = std::map<WifiSpectrumBandInfo, HeRu::RuSpec>;
+using RuBands = std::map<WifiSpectrumBandInfo, WifiRu::RuSpec>;
 
 /**
  * @brief 802.11 PHY layer model
@@ -226,8 +226,7 @@
      * @param guardBandwidth width of the guard band
      * @returns the computed RU bands for the spectrum PHY interface
      */
-    HeRuBands GetHeRuBands(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface,
-                           MHz_u guardBandwidth);
+    RuBands GetRuBands(Ptr<WifiSpectrumPhyInterface> spectrumPhyInterface, MHz_u guardBandwidth);
 
     /**
      * This function computes the bands that belong to a given spectrum PHY interface.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ssid.cc ns-3.45/src/wifi/model/ssid.cc
--- ns-3.44/src/wifi/model/ssid.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/ssid.cc	2025-06-01 20:34:45.624702200 -0700
@@ -43,7 +43,7 @@
 void
 Ssid::Print(std::ostream& os) const
 {
-    os << "ssid=" << PeekString();
+    os << "SSID=[" << PeekString() << "]";
 }
 
 bool
